 /* 
  Increment a variable in two processes.
  Check the final value.
  
  Simple program with no assertions and no LTL properties!
*/

#define TIMES 10  // Preprocessor constant definition
byte	n = 0;    // Type definition + initialisation of  variable
byte	finished = 0;

active [2] proctype P() {  // Pre-spawn 2 instances at start
	byte 	i = 1;
	byte	temp;
    
	do :: ( i > TIMES ) -> break  /* do block runs for ever
									 or until you hit the keyword "break"	
                                     :: says "guard follows"
                                     no guard = "true"
                                     :: choose one true guard (non-det!) */
                                     
	   :: else -> /* When no other guard holds, not mandatory */
		temp = n;
		n = temp + 1;  /* all single statements are atomic      */
        i++            /* but here n is incremented in 2 steps  */
		         
	od; /* end do loop */
	finished++; /* Process terminates so we add a count to 
                    our variable that keeps track */
}

active proctype Finish() {
	finished == 2;  /* Wait for termination of two processes
                       A predicate P means "await P" */ 
                       
    printf("n = %d\n", n); /* %d means use integer after the quote */
    
	assert (n >= 0 && n <= 20);  /* In this specific point of the program this
                                predicate should evaulate to true */
}