#define NUM_PHIL 5

//TODO: Assertions, deadlock
chan forks [NUM_PHIL] = [1] of {int}; /* (asynchronous) channel buffer
                                            with buffer of size 1 */
                                            
bool eating = false; //Meta-varialbe that checks if any philosopher is eating

int nrTimesForks [NUM_PHIL] = 0; /*Meta-variable to track how many philosophers
                                 are using the same fork (should be < 2 )   */

proctype phil(int id) {     /* non-active, must be spawned */
    int left = id;
    int right = (id+1) % NUM_PHIL;     // modulus 
    int fork1, fork2;                 // 1 means I'm holding fork, 0 means I'm not
  do 
    ::printf("philosopher %d thinking\n", id);
        if
            :: else ->                  /* All philosophers */
                forks [left] ? fork1;   /* Wait until you pick up the left fork */
                nrTimesForks[left]++;   /* Indicate that you are holding it */
                forks [right] ? fork2; /* Wait until you pick up the right fork */
                nrTimesForks[right]++ /* Indicate that you are holding it as well */
        fi;
        eating = true; /* Some philosopher is eating, global variabel */
        
        /* Make sure that only I am holding my right/left fork */
        assert (nrTimesForks[left] < 2 && nrTimesForks[right] < 2);
        
        printf("philosopher %d eating with fork %d and %d \n", id, fork1, fork2);
        
        eating = false; /* Someone stopped eating */
        if 
            :: else ->
                /*  Put down our forks, one at a time
                    in the same order that we picked 
                    them up. Indicate globally. */
                nrTimesForks[right]--;   
                forks [right] ! fork2;
                nrTimesForks[left]--;
                forks [left] ! fork1; 
        fi;
  od 
}

init  {
  int i = 0; 

  do 
  :: i >= NUM_PHIL -> break
  :: else -> run phil(i); forks [i] ! i; /* "Sit" each philosopher at the 
                                            table and put down 1 fork 
                                            to their left. */
             i++ 
  od;
 }